{ config, lib, pkgs, ... }:

let
  cfg = config.plugins.snippet.snippy;
in
{
  options.plugins.snippet.snippy = with lib; {
    enable = mkEnableOption "snippy";

    package = mkPackageOption pkgs.vimPlugins "nvim-snippy" { };
  };

  config = lib.mkIf cfg.enable {
    plugin.nvim-snippy = {
      inherit (cfg) package;
      name = "snippy";
    };
  };
}
