{ config, lib, pkgs, ... }:

let
  cfg = config.plugins.snippet.ultisnips;
in
{
  options.plugins.snippet.ultisnips = with lib; {
    enable = mkEnableOption "ultisnips";

    package = mkPackageOption pkgs.vimPlugins "ultisnips" { };
  };

  config = lib.mkIf cfg.enable {
    plugin.ultisnips = {
      inherit (cfg) package;
      name = "UltiSnips";
    };
  };
}
