{ config, lib, pkgs, ... }:

let
  cfg = config.plugins.snippet.vsnip;
in
{
  options.plugins.snippet.vsnip = with lib; {
    enable = mkEnableOption "vsnip";

    package = mkPackageOption pkgs.vimPlugins "vim-vsnip" { };
  };

  config = lib.mkIf cfg.enable {
    plugin.vim-vsnip = {
      inherit (cfg) package;
      name = "vsnip";
    };
  };
}
